#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# keras（Googleのライブラリー）を使った、手書き数字MNISTの学習プログラム

import keras
from keras.layers import Dense

(x_train, y_train), (x_test, y_test) = keras.datasets.mnist.load_data()

x_train = x_train.reshape(60000, 28*28).astype('float32') / 255
x_test  = x_test.reshape( 10000, 28*28).astype('float32') / 255

y_train = keras.utils.to_categorical(y_train, 10)
y_test  = keras.utils.to_categorical(y_test,  10)

model = keras.models.Sequential()
model.add(Dense(256, activation='relu', input_shape=(28*28,)))
model.add(Dense( 64, activation='relu'))
model.add(Dense( 10, activation='softmax'))

model.compile(loss='categorical_crossentropy', optimizer='Adam', metrics=['accuracy'])
history = model.fit(x_train, y_train, batch_size=100, epochs=20, validation_data=(x_test, y_test))

score = model.evaluate(x_test, y_test)
print('Test loss={}, Test accuracy={}'.format(score[0], score[1]))
