#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# 形式ニューロン、NOT素子の学習

import random

# 重みとバイアス、この2つの値を学習によって変化させる
W = random.random() # 重み、初期値をランダムに設定する（0.0以上1.0未満）
B = random.random() # バイアス、初期値をランダムに設定する（0.0以上1.0未満）

LEARNING_RATE = 0.1 # 学習係数 - 適切な小さな値を設定する

for trial in range(100):    # 100回訓練を繰り返す
    
    # 次の訓練データをランダムに用意する
    (x, y) = (1, 0) if random.randint(0,1) == 0 else (0, 1)
    
    # NOT素子（形式ニューロン）を動かす
    u = x * W + B
    result = 1 if u > 0 else 0
    
    if result != y: # 結果が間違っていた 
        if result == 0: # 本来 1が出てほしいのに 0が出た
            # 影響のあるところだけ更新する、W は更新しない
            B += LEARNING_RATE
        else:           # 本来 0が出てほしいのに 1が出た
            W -= LEARNING_RATE
            B -= LEARNING_RATE

# 結果を確認する
for x in [0, 1]:
    u = x * W + B
    result = 1 if u > 0 else 0
    print( "NOT", x, " = ", result )
