#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# 単回帰分析

import numpy as np
import pandas as pd

# 糖尿病患者データセット"diabetes"を取り出す
from sklearn import datasets
diabetes = datasets.load_diabetes()
df = pd.DataFrame(diabetes.data, columns=diabetes.feature_names)
train_x = np.array( df['bmi'] ) # 説明変数 = 入力データ、BMI値
train_y = diabetes.target       # 目的変数 = 教師データ、1年後の疾患の進み度合い

LEARNING_RATE = 0.01    # 学習係数 -- ここをうまく調整する

W = np.random.rand() * 1000     # 重みWを乱数で初期化
B = np.random.rand() * 1000     # バイアスBを乱数で初期化

for trial in range(300000):     # 訓練回数 -- とにかく多めにとらないと結果が安定しない
    
    rnd = np.random.randint(0, len(train_x)) 
        # ランダムに1個データを取り出す
    x = train_x[rnd]
    y = train_y[rnd]
    
    result = x * W + B  # 線形ニューロンの実行
    error = result - y  # 誤差
    
    W -= ( LEARNING_RATE * error * x )  # 重みの更新
    B -= ( LEARNING_RATE * error )      # バイアスの更新

# 学習の結果、得られた重みとバイアスの適正値
print( "y = {} x + {}".format(W, B) )
