#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# 重回帰分析

import numpy as np

# 糖尿病患者データセット"diabetes"を取り出す
from sklearn import datasets
diabetes = datasets.load_diabetes()
train_x = diabetes.data     # 説明変数 = 入力データ、すべての変数を用いる★
train_y = diabetes.target   # 目的変数 = 教師データ、1年後の疾患の進み度合い
n_data, n_input = train_x.shape # 全データ件数、入力データの数★

LEARNING_RATE = 0.01    # 学習係数 -- ここをうまく調整する

W = np.random.rand(n_input) * 1000  # 入力の数だけある重みを乱数で初期化★
B = np.random.rand() * 1000 # バイアスを乱数で初期化

for trial in range(3000000):  # 訓練回数 -- もっと多めにとらないと結果が安定しない★

    rnd = np.random.randint(0, n_data)  
        # ランダムに1個データを取り出す
    x = train_x[rnd]
    y = train_y[rnd]
    
    result = np.sum( x * W ) + B    # 線形ニューロンの実行★
    error = result - y  # 誤差
    
    W -= ( LEARNING_RATE * error * x )  # 重みの更新
    B -= ( LEARNING_RATE * error )      # バイアスの更新

# 学習の結果、得られた重みとバイアスの適正値
print( "y = {} x + {}".format(W, B) )
